import java.awt.*;

public class Judge {

double ftop, fscore1, fscore2;
int itrials;
Label score1, score2, trials, top, bottom;
Chief chief;
double payoff1[][], payoff2[][];
Graph graph;
double pmax,pmin;

void setPayoff(double ppayoff1[][], double ppayoff2[][]) {
	payoff1=ppayoff1; payoff2=ppayoff2;
	pmin=pmax=(double)payoff1[0][0];
	for(int i=0; i<2; i++)
	{
		for(int j=0; j<2; j++)
		{
		 if ((double)payoff1[i][j]<pmin) pmin =	(double)payoff1[i][j];
		 if ((double)payoff2[i][j]<pmin) pmin =	(double)payoff2[i][j];
		 if ((double)payoff1[i][j]>pmax) pmax =	(double)payoff1[i][j];
		 if ((double)payoff2[i][j]>pmax) pmax =	(double)payoff2[i][j];
		}
	}
	}

Judge(Label pscore1, Label pscore2, Label ptrials, Label ptop,
	  Label pbottom,Graph pgraph) {
		graph=pgraph;
		score1=pscore1;
		score2=pscore2;
		trials=ptrials;
		top=ptop;
		bottom=pbottom;
		ftop=.5;
		fscore1=0.0;
		fscore2=0.0;
		itrials=0;
		chief = new Chief();
		this.next();

}


	void next() {
		float ffscore1, ffscore2;
		double temp[];
		temp=new double[3];
		ffscore1=(float) fscore1;
		ffscore2=(float) fscore2;
		ftop=chief.predict();
		score1.setText("R SCORE="+ffscore1);
		score2.setText("C SCORE="+ffscore2);
		trials.setText("TRIALS="+itrials);
		top.setText(""+ftop);
		bottom.setText(""+(1.0-ftop));
		temp[0]=Math.log(1+(double)itrials);
		temp[1]=(double)fscore1;
		temp[2]=(double)fscore2;
		graph.setScale(0,pmin,Math.log(1+(double)itrials),pmax);
		graph.addRow(temp);
	}

	public void update(boolean istop) {
		if(istop) {
			fscore1=((fscore1*itrials)+(ftop*payoff1[0][0]+(1-ftop)*payoff1[1][0]))/(itrials+1);
			fscore2=((fscore2*itrials)+(ftop*payoff2[0][0]+(1-ftop)*payoff2[1][0]))/(itrials+1);
		}
		else {
			fscore1=((fscore1*itrials)+(ftop*payoff1[0][1]+(1-ftop)*payoff1[1][1]))/(itrials+1);
			fscore2=((fscore2*itrials)+(ftop*payoff2[0][1]+(1-ftop)*payoff2[1][1]))/(itrials+1);
		}
		itrials++;
		chief.update(istop);
		this.next();
	}

}

